import Vue 				from 'vue';
import VueRouter 		from 'vue-router';
import routes 			from '@/router/common/routes.js';
import { globalConfig }	from '@/service/common/config.js';
import cache 			from '@/service/common/cache';
import store 			from '@/store';
import comolayer 		from 'vue-como-layer';
Vue.use(VueRouter)
const router = new VueRouter({
    mode: 'hash',
    base: process.env.BASE_URL,
    routes
})

router.beforeEach(async (to, from, next) => {
	try {
		next();
	} catch(err) {
		return comolayer.alert(err.message,{title:'权限拦截提醒',icon:2,shade:true});
	}
})

export default router;